<?php
/**
 * @file
 * popup window for isdn and anolog groups
 */
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');

$load_popup = 1;
$invalid = array();

/* [CHECKING GET VARIABLE] */
$list_get = array(	'start' => 'start'	, 
			'id'	=> 'id'		);

$_GET = Helper::sanitizeGet($_GET, $list_get, $load_popup, $invalid);

/* [CHECKING POST] */
unset($_POST);

/* [DISPLAYING POPUP] */
if (!$load_popup) {
	echo "<script>window.location='../../index.php?m=Acl&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

chdir("../..");

include "./includes/variables.php";
include_once("/usr/www/include/SQLite2ToSQLite3.php");
include "./misc/database.php";
include("./misc/config_parameter.php");
$ba = new beroAri();
require_once ('./includes/lang.php');
require_once('/usr/local/www/berogui/includes/session.php');

$id = sqlite_escape_string($_GET['id']);
$start = $_GET['start'];

?>
<script type="text/javascript">
    $("#acll").validate({
                    
        rules: {
                        
            address: { 
                checkHostname : true, 
                required: true
            },
            netmask: {
                required:true,
                digits: true,
                range: [0,32],
                },
                manual_dest_port: {
                    required: {
                        depends: function (element) {
                            return $("#dest_port option:selected").val() == "manual";
                        }
                    },
                    digits: true,
                    range: [1, 65535],
                },
            }
        });

        $("#dest_port").change(function () {
            required();
        });

        function required() {
            if ($("#dest_port option:selected").val() == "manual") {
                addAsterisk("manual_dest_port");
            } else {
                deleteAsterisk("manual_dest_port");
            }
        }

        function hide_elements() {
            if ($('#dest_port').val() === "manual")
                $('#manual_dest_port').show();
            else
                $('#manual_dest_port').hide();
        }
	
	$( document ).ready(function() {
		hide_elements();
		required();
	});

</script>
<?php

function protocol($id){
    $allProtocol=array(""=>"All","udp"=>"UDP","tcp"=>"TCP");
    if ($id!="") $protocol=  getValue ($id, "protocol");
    $result="<select name='protocol' class='form-control'>";
    foreach ($allProtocol as $key=>$value){
        ($key===$protocol) ? $selected="selected='true'" : $selected="";
        $result.="<option value='$key' $selected>$value</option>";
    }
    $result.="</select>";
    return $result;
}

function stack($id) {
	$allStack = array (
			"" => "ANY",
			"LAN" => "LAN",
			"WAN" => "WAN"
	);
	
	if ($id != "") {
		$stack = getValue ( $id, "stack" );
	}
	
	$result = "<select name='stack' class='form-control'>";
	foreach ( $allStack as $key => $value ) {
		($key === $stack) ? $selected = "selected='true'" : $selected = "";
		$result .= "<option value='$key' $selected>$value</option>";
	}
	$result .= "</select>";
	return $result;
}

function dest_port($id){
    $port=array(-1=>"SIP",-2=>"SIP-TLS",80=>"HTTP",443=>"HTTPS",54322=>"Telnet",22=>"SSH",161=>"SNMP",162=>"SNMP-Trap",65001=>"bfdetect","all" => "All");
    if ($id!="") {
        $dest_port=  getValue ($id, "dest_port");
        if (!array_key_exists($dest_port, $port)){
            $manual="selected='true'";
            $manual_port=$dest_port;
        }
    }
    $result="<select name='dest_port' id='dest_port' onchange='hide_elements();' class='form-control'>";
    foreach ($port as $key=>$value){
        ($key==$dest_port) ? $selected="selected='true'" : $selected="";
        $result.="<option value='$key' $selected >$value</option>";
    }
    $result.="<option value='manual' $manual>Manual</option>";
    
    $result.="<input name='manual_dest_port' class='form-control input-sm' id='manual_dest_port' value='$manual_port'>";
    $result.="</select>";
    return $result;
}

function acl_rule($id){
    $address= getValue ($id, "address");
    $netmask= getValue ($id, "netmask");
    $result="<div class='col-sm-7' style='padding-left:0px'><input type='text' name='address' value='$address' size='15' class='form-control input-sm' /></div>"
	    . "<div class='col-sm-1'>/</div>"
	    . "<div class='col-sm-4'><input type='text' name='netmask' class='form-control input-sm' value='$netmask'size='2' /></div>\n";
    return $result;
}

function getValue($id,$colname){
    $ba=new beroAri();
    $query=$ba->select("select $colname from acl where id='$id'");
    return sqlite_fetch_single($query);
}


function show_stack_field_on_lanwan() {
	$bc = new beroConf ( 'root' );
	if ($bc->get ( 'root', 'lan-mode' ) == 'lan-wan') {
		return 1;
	}
	else {
		return 0;
	}
}

require_once "./includes/isgwtelnet.php";

?>
<form class='form-horizontal' name='acll' id='acll' action='modules/Acl/acl_submit.php' method='POST'>
        <input type=hidden name='start' value='<?php echo $start; ?>'>
	<div class='form-group'>
	    <label for='protocol' class='col-sm-4 control-label'><?php echo ACL_PROTOCOL_DIS; ?></label>
	    <div class='col-sm-6'>
		<?php echo protocol($id); ?>
	    </div>
	</div>
	
<?php
if (show_stack_field_on_lanwan()) {
?>
	<div class='form-group'>
	    <label for='stack' class='col-sm-4 control-label'><?php echo "Stack"; ?></label>
	    <div class='col-sm-6'>
		<?php echo stack($id); ?>
	    </div>
	</div>
	
<?php }
?>
	
	<div class='form-group'>
	    <label for='manual_dest_port' class='col-sm-4 control-label'><?php echo ACL_DEST_PORT_DIS; ?></label>
	    <div class='col-sm-6'>
		<?php echo dest_port($id); ?>
	    </div>
	</div>
	<div class='form-group'>
	    <label for='address' class='col-sm-4 control-label'><?php echo ACL_ACL_RULE_DIS; ?></label>
	    <div class='col-sm-6'>
		<?php echo acl_rule($id); ?>
	    </div>
	</div>
	<div class='text-center'><i><?php echo REQUIRED_FIELDS; ?></i></div>
	<br/>
	<input type='hidden' name='id_upd' value='<?php echo $id; ?>'>
	<div class='text-center'>
		<button type='submit' class='btn btn-default'><?php echo BUTTON_SAVE; ?></button>
	</div>
</form>
